# coding: utf-8

"""
    CityPay Payment API

     This CityPay API is a HTTP RESTful payment API used for direct server to server transactional processing. It provides a number of payment mechanisms including: Internet, MOTO, Continuous Authority transaction processing, 3-D Secure decision handling using RFA Secure, Authorisation, Refunding, Pre-Authorisation, Cancellation/Voids and Completion processing. The API is also capable of tokinsed payments using Card Holder Accounts.  ## Compliance and Security <aside class=\"notice\">   Before we begin a reminder that your application will need to adhere to PCI-DSS standards to operate safely   and to meet requirements set out by Visa and MasterCard and the PCI Security Standards Council including: </aside>  * Data must be collected using TLS version 1.2 using [strong cryptography](#enabled-tls-ciphers). We will not accept calls to our API at   lower grade encryption levels. We regularly scan our TLS endpoints for vulnerabilities and perform TLS assessments   as part of our compliance program. * The application must not store sensitive card holder data (CHD) such as the card security code (CSC) or   primary access number (PAN) * The application must not display the full card number on receipts, it is recommended to mask the PAN   and show the last 4 digits. The API will return this for you for ease of receipt creation * If you are developing a website, you will be required to perform regular scans on the network where you host the   application to meet your compliance obligations * You will be required to be PCI Compliant and the application must adhere to the security standard. Further information   is available from [https://www.pcisecuritystandards.org/](https://www.pcisecuritystandards.org/) * The API verifies that the request is for a valid account and originates from a trusted source using the remote IP   address. Our application firewalls analyse data that may be an attempt to break a large number of security common   security vulnerabilities.   # noqa: E501

    Contact: support@citypay.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from citypay.configuration import Configuration


class Decision(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'authen_required': 'AuthenRequired',
        'auth_response': 'AuthResponse',
        'request_challenged': 'RequestChallenged'
    }

    attribute_map = {
        'authen_required': 'AuthenRequired',
        'auth_response': 'AuthResponse',
        'request_challenged': 'RequestChallenged'
    }

    def __init__(self, authen_required=None, auth_response=None, request_challenged=None, local_vars_configuration=None):  # noqa: E501
        """Decision - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._authen_required = None
        self._auth_response = None
        self._request_challenged = None
        self.discriminator = None

        if authen_required is not None:
            self.authen_required = authen_required
        if auth_response is not None:
            self.auth_response = auth_response
        if request_challenged is not None:
            self.request_challenged = request_challenged

    @property
    def authen_required(self):
        """Gets the authen_required of this Decision.  # noqa: E501


        :return: The authen_required of this Decision.  # noqa: E501
        :rtype: AuthenRequired
        """
        return self._authen_required

    @authen_required.setter
    def authen_required(self, authen_required):
        """Sets the authen_required of this Decision.


        :param authen_required: The authen_required of this Decision.  # noqa: E501
        :type: AuthenRequired
        """

        self._authen_required = authen_required

    @property
    def auth_response(self):
        """Gets the auth_response of this Decision.  # noqa: E501


        :return: The auth_response of this Decision.  # noqa: E501
        :rtype: AuthResponse
        """
        return self._auth_response

    @auth_response.setter
    def auth_response(self, auth_response):
        """Sets the auth_response of this Decision.


        :param auth_response: The auth_response of this Decision.  # noqa: E501
        :type: AuthResponse
        """

        self._auth_response = auth_response

    @property
    def request_challenged(self):
        """Gets the request_challenged of this Decision.  # noqa: E501


        :return: The request_challenged of this Decision.  # noqa: E501
        :rtype: RequestChallenged
        """
        return self._request_challenged

    @request_challenged.setter
    def request_challenged(self, request_challenged):
        """Sets the request_challenged of this Decision.


        :param request_challenged: The request_challenged of this Decision.  # noqa: E501
        :type: RequestChallenged
        """

        self._request_challenged = request_challenged

    def is_authen_required(self):
        return self.authen_required != None

    def is_request_challenged(self):
        return self.request_challenged != None

    def is_auth_response(self):
        return self.auth_response != None


    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Decision):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Decision):
            return True

        return self.to_dict() != other.to_dict()
