# coding: utf-8

"""
    CityPay Payment API

     This CityPay API is a HTTP RESTful payment API used for direct server to server transactional processing. It provides a number of payment mechanisms including: Internet, MOTO, Continuous Authority transaction processing, 3-D Secure decision handling using RFA Secure, Authorisation, Refunding, Pre-Authorisation, Cancellation/Voids and Completion processing. The API is also capable of tokinsed payments using Card Holder Accounts.  ## Compliance and Security <aside class=\"notice\">   Before we begin a reminder that your application will need to adhere to PCI-DSS standards to operate safely   and to meet requirements set out by Visa and MasterCard and the PCI Security Standards Council including: </aside>  * Data must be collected using TLS version 1.2 using [strong cryptography](#enabled-tls-ciphers). We will not accept calls to our API at   lower grade encryption levels. We regularly scan our TLS endpoints for vulnerabilities and perform TLS assessments   as part of our compliance program. * The application must not store sensitive card holder data (CHD) such as the card security code (CSC) or   primary access number (PAN) * The application must not display the full card number on receipts, it is recommended to mask the PAN   and show the last 4 digits. The API will return this for you for ease of receipt creation * If you are developing a website, you will be required to perform regular scans on the network where you host the   application to meet your compliance obligations * You will be required to be PCI Compliant and the application must adhere to the security standard. Further information   is available from [https://www.pcisecuritystandards.org/](https://www.pcisecuritystandards.org/) * The API verifies that the request is for a valid account and originates from a trusted source using the remote IP   address. Our application firewalls analyse data that may be an attempt to break a large number of security common   security vulnerabilities.   # noqa: E501

    Contact: support@citypay.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from citypay.configuration import Configuration


class ListMerchantsResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'client_name': 'str',
        'clientid': 'str',
        'merchants': 'list[Merchant]'
    }

    attribute_map = {
        'client_name': 'client_name',
        'clientid': 'clientid',
        'merchants': 'merchants'
    }

    def __init__(self, client_name=None, clientid=None, merchants=None, local_vars_configuration=None):  # noqa: E501
        """ListMerchantsResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._client_name = None
        self._clientid = None
        self._merchants = None
        self.discriminator = None

        if client_name is not None:
            self.client_name = client_name
        if clientid is not None:
            self.clientid = clientid
        if merchants is not None:
            self.merchants = merchants

    @property
    def client_name(self):
        """Gets the client_name of this ListMerchantsResponse.  # noqa: E501

        The client name that was requested.  # noqa: E501

        :return: The client_name of this ListMerchantsResponse.  # noqa: E501
        :rtype: str
        """
        return self._client_name

    @client_name.setter
    def client_name(self, client_name):
        """Sets the client_name of this ListMerchantsResponse.

        The client name that was requested.  # noqa: E501

        :param client_name: The client_name of this ListMerchantsResponse.  # noqa: E501
        :type: str
        """

        self._client_name = client_name

    @property
    def clientid(self):
        """Gets the clientid of this ListMerchantsResponse.  # noqa: E501

        The client id requested.  # noqa: E501

        :return: The clientid of this ListMerchantsResponse.  # noqa: E501
        :rtype: str
        """
        return self._clientid

    @clientid.setter
    def clientid(self, clientid):
        """Sets the clientid of this ListMerchantsResponse.

        The client id requested.  # noqa: E501

        :param clientid: The clientid of this ListMerchantsResponse.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                clientid is not None and len(clientid) > 10):
            raise ValueError("Invalid value for `clientid`, length must be less than or equal to `10`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                clientid is not None and len(clientid) < 3):
            raise ValueError("Invalid value for `clientid`, length must be greater than or equal to `3`")  # noqa: E501

        self._clientid = clientid

    @property
    def merchants(self):
        """Gets the merchants of this ListMerchantsResponse.  # noqa: E501


        :return: The merchants of this ListMerchantsResponse.  # noqa: E501
        :rtype: list[Merchant]
        """
        return self._merchants

    @merchants.setter
    def merchants(self, merchants):
        """Sets the merchants of this ListMerchantsResponse.


        :param merchants: The merchants of this ListMerchantsResponse.  # noqa: E501
        :type: list[Merchant]
        """

        self._merchants = merchants

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ListMerchantsResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ListMerchantsResponse):
            return True

        return self.to_dict() != other.to_dict()
