# coding: utf-8

"""
    CityPay Payment API

     This CityPay API is a HTTP RESTful payment API used for direct server to server transactional processing. It provides a number of payment mechanisms including: Internet, MOTO, Continuous Authority transaction processing, 3-D Secure decision handling using RFA Secure, Authorisation, Refunding, Pre-Authorisation, Cancellation/Voids and Completion processing. The API is also capable of tokinsed payments using Card Holder Accounts.  ## Compliance and Security <aside class=\"notice\">   Before we begin a reminder that your application will need to adhere to PCI-DSS standards to operate safely   and to meet requirements set out by Visa and MasterCard and the PCI Security Standards Council including: </aside>  * Data must be collected using TLS version 1.2 using [strong cryptography](#enabled-tls-ciphers). We will not accept calls to our API at   lower grade encryption levels. We regularly scan our TLS endpoints for vulnerabilities and perform TLS assessments   as part of our compliance program. * The application must not store sensitive card holder data (CHD) such as the card security code (CSC) or   primary access number (PAN) * The application must not display the full card number on receipts, it is recommended to mask the PAN   and show the last 4 digits. The API will return this for you for ease of receipt creation * If you are developing a website, you will be required to perform regular scans on the network where you host the   application to meet your compliance obligations * You will be required to be PCI Compliant and the application must adhere to the security standard. Further information   is available from [https://www.pcisecuritystandards.org/](https://www.pcisecuritystandards.org/) * The API verifies that the request is for a valid account and originates from a trusted source using the remote IP   address. Our application firewalls analyse data that may be an attempt to break a large number of security common   security vulnerabilities.   # noqa: E501

    Contact: support@citypay.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from citypay.configuration import Configuration


class MCC6012(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'recipient_account': 'str',
        'recipient_dob': 'str',
        'recipient_lastname': 'str',
        'recipient_postcode': 'str'
    }

    attribute_map = {
        'recipient_account': 'recipient_account',
        'recipient_dob': 'recipient_dob',
        'recipient_lastname': 'recipient_lastname',
        'recipient_postcode': 'recipient_postcode'
    }

    def __init__(self, recipient_account=None, recipient_dob=None, recipient_lastname=None, recipient_postcode=None, local_vars_configuration=None):  # noqa: E501
        """MCC6012 - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._recipient_account = None
        self._recipient_dob = None
        self._recipient_lastname = None
        self._recipient_postcode = None
        self.discriminator = None

        if recipient_account is not None:
            self.recipient_account = recipient_account
        if recipient_dob is not None:
            self.recipient_dob = recipient_dob
        if recipient_lastname is not None:
            self.recipient_lastname = recipient_lastname
        if recipient_postcode is not None:
            self.recipient_postcode = recipient_postcode

    @property
    def recipient_account(self):
        """Gets the recipient_account of this MCC6012.  # noqa: E501

        The account number of the recipient.  # noqa: E501

        :return: The recipient_account of this MCC6012.  # noqa: E501
        :rtype: str
        """
        return self._recipient_account

    @recipient_account.setter
    def recipient_account(self, recipient_account):
        """Sets the recipient_account of this MCC6012.

        The account number of the recipient.  # noqa: E501

        :param recipient_account: The recipient_account of this MCC6012.  # noqa: E501
        :type: str
        """

        self._recipient_account = recipient_account

    @property
    def recipient_dob(self):
        """Gets the recipient_dob of this MCC6012.  # noqa: E501

        The date of birth of the recipient.  # noqa: E501

        :return: The recipient_dob of this MCC6012.  # noqa: E501
        :rtype: str
        """
        return self._recipient_dob

    @recipient_dob.setter
    def recipient_dob(self, recipient_dob):
        """Sets the recipient_dob of this MCC6012.

        The date of birth of the recipient.  # noqa: E501

        :param recipient_dob: The recipient_dob of this MCC6012.  # noqa: E501
        :type: str
        """

        self._recipient_dob = recipient_dob

    @property
    def recipient_lastname(self):
        """Gets the recipient_lastname of this MCC6012.  # noqa: E501

        The lastname of ther recepient.  # noqa: E501

        :return: The recipient_lastname of this MCC6012.  # noqa: E501
        :rtype: str
        """
        return self._recipient_lastname

    @recipient_lastname.setter
    def recipient_lastname(self, recipient_lastname):
        """Sets the recipient_lastname of this MCC6012.

        The lastname of ther recepient.  # noqa: E501

        :param recipient_lastname: The recipient_lastname of this MCC6012.  # noqa: E501
        :type: str
        """

        self._recipient_lastname = recipient_lastname

    @property
    def recipient_postcode(self):
        """Gets the recipient_postcode of this MCC6012.  # noqa: E501

        The postcode of the recipient.  # noqa: E501

        :return: The recipient_postcode of this MCC6012.  # noqa: E501
        :rtype: str
        """
        return self._recipient_postcode

    @recipient_postcode.setter
    def recipient_postcode(self, recipient_postcode):
        """Sets the recipient_postcode of this MCC6012.

        The postcode of the recipient.  # noqa: E501

        :param recipient_postcode: The recipient_postcode of this MCC6012.  # noqa: E501
        :type: str
        """

        self._recipient_postcode = recipient_postcode

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MCC6012):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MCC6012):
            return True

        return self.to_dict() != other.to_dict()
